<script setup lang="ts">
import { useSizeStore } from '@/stores/size'
import { useSubCategoryStore } from '@/stores/subCategory'
import { type Product } from '@/types/Product'
import type { Size } from '@/types/Size'
import type { SubCategory } from '@/types/SubCategory'
import { computed, onMounted, ref, type Ref } from 'vue'
import { useCategoryStore } from '@/stores/category'
const sizeStore = useSizeStore()
const subCategoryStore = useSubCategoryStore()

const dialog = ref(false)

function openForm() {
  dialog.value = true
}
function save() {
  const product = <Product>{
    id: props.product.id,
    name: props.product.name,
    price: props.product.price,
    unit: props.product.unit,
    category: props.product.category,
    subCategory: props.product.subCategory,
    size: props.product.size,
    subCategorys: props.product.subCategorys,
    sizes: props.product.sizes,
    image: props.product.image
  }
  console.log(product.sizes)
  emit('selectedProduct', product)

  dialog.value = false
}
function cancel() {
  dialog.value = false
}
const props = defineProps<{
  product: Product
}>()
const emit = defineEmits<{
  selectedProduct: [Product]
}>()
const selected = function () {
  const a = <Product>{
    id: props.product.id,
    name: props.product.name,
    price: props.product.price,
    unit: props.product.unit,
    category: props.product.category,
    subCategory: props.product.subCategory,
    size: props.product.size,
    image: props.product.image
  }
  console.log(a)
  emit('selectedProduct', a)
}
const isFormValid = computed(() => {
  return props.product.size && props.product.subCategory
})
onMounted(async () => {
  await subCategoryStore.getSubCategorys()
  await sizeStore.getSizes()
})
</script>
<template>
  <v-sheet width="200" height="125" elevation="3" @click="openForm()" rounded>
    <v-container>
      <v-row>
        <v-col cols="5">
          <v-img :src="'http://localhost:3000/images/products/' + props.product.image" height="80" cover></v-img>
          <div style="text-align: center; color:">฿ {{ product.price }}</div>
        </v-col>
        <v-col cols="7" class="pl-0 pt-1">
          <div style="text-align: center; font-size: 14px">{{ product.name }}</div>
        </v-col>
      </v-row>
    </v-container>
  </v-sheet>

  <v-dialog v-model="dialog" max-width="600" activator="false">
    <v-card>
      <v-card-title>Product</v-card-title>
      <v-card-text>
        <v-form ref="form">
          <v-row>
            <v-col cols="12" sm="12" md="4">
              <v-row>
                <v-img
                  :src="'http://localhost:3000/images/products/' + props.product.image"
                  width="200"
                  height="200"
                >
                </v-img>
              </v-row>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-row>
                <div style="font-size: 30px">
                  {{ props.product.name }}
                </div> </v-row
              ><v-row>
                <div style="font-size: 25px">
                  {{ props.product.price + ' Bath' }}
                </div>
              </v-row>
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="12" sm="6">
              <v-combobox
                label="Size"
                :items="props.product.sizes"
                item-title="name"
                item-value="id"
                :return-object="true"
                v-model="props.product.size"
              ></v-combobox>
            </v-col>
            <v-col cols="12" sm="6">
              <v-combobox
                label="Sub Category"
                :items="props.product.subCategorys"
                item-title="name"
                item-value="id"
                :return-object="true"
                v-model="props.product.subCategory"
              ></v-combobox>
            </v-col>
          </v-row>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-btn color="primary" @click="save" :disabled="!isFormValid">Save</v-btn>
        <v-btn color="primary" @click="cancel">Cancel</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style></style>
